
<!DOCTYPE HTML>
<html lang="" >
    <head>
        <meta charset="UTF-8">
        <meta content="text/html; charset=utf-8" http-equiv="Content-Type">
        <title>Docker · GitBook</title>
        <meta http-equiv="X-UA-Compatible" content="IE=edge" />
        <meta name="description" content="">
        <meta name="generator" content="GitBook 3.2.3">
        
        
        
    
    <link rel="stylesheet" href="gitbook/style.css">

    
            
                
                <link rel="stylesheet" href="gitbook/gitbook-plugin-highlight/website.css">
                
            
                
                <link rel="stylesheet" href="gitbook/gitbook-plugin-search/search.css">
                
            
                
                <link rel="stylesheet" href="gitbook/gitbook-plugin-fontsettings/website.css">
                
            
        

    

    
        
    
        
    
        
    
        
    
        
    
        
    

        
    
    
    <meta name="HandheldFriendly" content="true"/>
    <meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=no">
    <meta name="apple-mobile-web-app-capable" content="yes">
    <meta name="apple-mobile-web-app-status-bar-style" content="black">
    <link rel="apple-touch-icon-precomposed" sizes="152x152" href="gitbook/images/apple-touch-icon-precomposed-152.png">
    <link rel="shortcut icon" href="gitbook/images/favicon.ico" type="image/x-icon">

    
    <link rel="next" href="GitBook.html" />
    
    
    <link rel="prev" href="Ansible.html" />
    

    </head>
    <body>
        
<div class="book">
    <div class="book-summary">
        
            
<div id="book-search-input" role="search">
    <input type="text" placeholder="Type to search" />
</div>

            
                <nav role="navigation">
                


<ul class="summary">
    
    

    

    
        
        
    
        <li class="chapter " data-level="1.1" data-path="./">
            
                <a href="./">
            
                    
                    Introdução
            
                </a>
            

            
        </li>
    
        <li class="chapter " data-level="1.2" data-path="Vagrant.html">
            
                <a href="Vagrant.html">
            
                    
                    Vagrant
            
                </a>
            

            
        </li>
    
        <li class="chapter " data-level="1.3" data-path="Ansible.html">
            
                <a href="Ansible.html">
            
                    
                    Ansible
            
                </a>
            

            
        </li>
    
        <li class="chapter active" data-level="1.4" data-path="Docker.html">
            
                <a href="Docker.html">
            
                    
                    Docker
            
                </a>
            

            
        </li>
    
        <li class="chapter " data-level="1.5" data-path="GitBook.html">
            
                <a href="GitBook.html">
            
                    
                    GitBook
            
                </a>
            

            
        </li>
    

    

    <li class="divider"></li>

    <li>
        <a href="https://www.gitbook.com" target="blank" class="gitbook-link">
            Published with GitBook
        </a>
    </li>
</ul>


                </nav>
            
        
    </div>

    <div class="book-body">
        
            <div class="body-inner">
                
                    

<div class="book-header" role="navigation">
    

    <!-- Title -->
    <h1>
        <i class="fa fa-circle-o-notch fa-spin"></i>
        <a href="." >Docker</a>
    </h1>
</div>




                    <div class="page-wrapper" tabindex="-1" role="main">
                        <div class="page-inner">
                            
<div id="book-search-results">
    <div class="search-noresults">
    
                                <section class="normal markdown-section">
                                
                                <h1 id="docker">Docker</h1>
<h1 id="o-que-s&#xE3;o-containers-">O que s&#xE3;o containers: </h1>
<p>Um container &#xE9; um conjunto composto por uma aplica&#xE7;&#xE3;o e suas depend&#xEA;ncia que compartilham o kernel do sistema operacional da m&#xE1;quina host.</p>
<p>S&#xE3;o parecidas com m&#xE1;quinas virtuais, entretanto s&#xE3;o mais leves e mais integrados a m&#xE1;quina host, o que permite um melhor desempenho por conta do gerenciamento de recursos.</p>
<h1 id="diferen&#xE7;as-entre-vm-e-container">Diferen&#xE7;as entre VM e CONTAINER</h1>
<p><img src="vm-container.png" alt="vmxcontainer"></p>
<ol>
<li>N&#xE3;o &#xE9; necess&#xE1;rio emular um novo sistema operacional quando estamos utilizando containers.</li>
<li>A virtualiza&#xE7;&#xE3;o permite o isolamento total do ambiente da sua aplica&#xE7;&#xE3;o, j&#xE1; que ela virtualiza a m&#xE1;quina por completo. O containere compartilha um mesmo kernel do sistema operacional, levando a um isolamento apenas parcial. </li>
<li>Containers necessitam de menos recursos.</li>
</ol>
<h2 id="kernel-features">Kernel features</h2>
<p>Como dito anteriormente, o docker utiliza recursos do kernel linux para o seu funcionamento. Na imagem abaixo podemos visualizar os m&#xF3;dulos utilizados:</p>
<p><img src="docker-kernel.png" alt="vmxcontainer"></p>
<h2 id="namespaces">Namespaces</h2>
<p>Este m&#xF3;dulo permite o isolamento de processos. Ou seja, gra&#xE7;as a este m&#xF3;dulo, cada container possui a sua pr&#xF3;pria &#xE1;rvore de processos, pontos de montagem, etc, fazendo com que um container n&#xE3;o interfira na execu&#xE7;&#xE3;o de outro.</p>
<h2 id="cgroups">Cgroups</h2>
<p>Este m&#xF3;dulo &#xE9; respons&#xE1;vel pela limita&#xE7;&#xE3;o do uso de recursos do host pelos containers. &#xC9; o cgroup que permite o gerenciamento de cpu, mem&#xF3;ria, I/O, etc.</p>
<h2 id="netfilter">Netfilter</h2>
<p>Este m&#xF3;dulo &#xE9; utilizado para que os containers consigam se comunicar. Atrav&#xE9;s dele o Docker constr&#xF3;i diversas regras de roteamento.</p>
<h2 id="instala&#xE7;&#xE3;o">Instala&#xE7;&#xE3;o</h2>
<pre><code class="lang-bash"> sudo apt-get update
 sudo apt-get install \
    apt-transport-https \
    ca-certificates \
    curl \
    gnupg \
    lsb-release

 curl -fsSL https://download.docker.com/linux/ubuntu/gpg | sudo gpg --dearmor -o /usr/share/keyrings/docker-archive-keyring.gpg
 <span class="hljs-built_in">echo</span> \
  <span class="hljs-string">&quot;deb [arch=amd64 signed-by=/usr/share/keyrings/docker-archive-keyring.gpg] https://download.docker.com/linux/ubuntu \
  <span class="hljs-variable">$(lsb_release -cs)</span> stable&quot;</span> | sudo tee /etc/apt/sources.list.d/docker.list &gt; /dev/null
 sudo apt-get update
 sudo apt-get install docker-ce docker-ce-cli containerd.io
</code></pre>
<h2 id="adhoc">Adhoc</h2>
<h3 id="o-que-s&#xE3;o-comandos-adhoc">O que s&#xE3;o comandos adhoc?</h3>
<p>Comandos utilizados para uma &#xFA;nica finalidade.</p>
<p>Estrutura dos comandos adhoc:</p>
<ul>
<li>docker container [comando]</li>
<li>docker image [comando]</li>
<li>docker volume [comando]</li>
<li>docker network [comando]</li>
</ul>
<h2 id="lista-de-comandos">Lista de comandos:</h2>
<pre><code class="lang-bash">docker container start [CONTAINER ID]
docker container stop [CONTAINER ID]
docker container restart [CONTAINER ID]
docker container pause [CONTAINER ID]
docker container unpause [CONTAINER ID]
docker container inspect [CONTAINER ID]
docker container logs <span class="hljs-_">-f</span> [CONTAINER ID]
docker container rm [CONTAINER ID]
docker container attach [CONTAINER ID]
docker container rm <span class="hljs-_">-f</span> [CONTAINER ID]
docker container <span class="hljs-built_in">exec</span> -ti [CONTAINER ID] [COMANDO]
docker container run <span class="hljs-_">-d</span> nginx
docker container stats [CONTAINER ID]
docker container top [CONTAINER ID]
docker container run <span class="hljs-_">-d</span> -m 128M --cpus 0.5 nginx
docker container update --memory 64M --cpus 0.4 nginx
docker container inspect [CONTAINER ID]
docker container stats [CONTAINER ID]
docker container top [CONTAINER ID]
</code></pre>
<h1 id="dockerfile">Dockerfile</h1>
<p>O <a href="https://docs.docker.com/engine/reference/builder/" target="_blank">dockerfile</a> &#xE9; como se fosse a &quot;planta baixa&quot; de um container. L&#xE1; &#xE9; onde ser&#xE1; determinado todos os detalhes do seu container, como, por exemplo, a imagem a ser utilizada, aplicativos que necessitam ser instalados, comandos a serem executados, os volumes que ser&#xE3;o montados, etc.</p>
<h3 id="exemplo-dockerfile">Exemplo dockerfile:</h3>
<pre><code class="lang-Dockerfile"><span class="hljs-keyword">FROM</span> alpine

<span class="hljs-keyword">RUN</span> <span class="bash">/bin/<span class="hljs-built_in">echo</span> <span class="hljs-string">&quot;HELLO DOCKER&quot;</span>
</span></code></pre>
<h3 id="sintaxe">Sintaxe:</h3>
<pre><code class="lang-Dockerfile"><span class="hljs-keyword">FROM</span> <span class="hljs-comment"># Indica qual imagem ser&#xE1; utilizada como base, ela precisa ser a primeira linha do Dockerfile;</span>
ADD <span class="hljs-comment">#Copia novos arquivos, diret&#xF3;rios, arquivos TAR ou arquivos remotos e os adicionam ao filesystem do container;</span>
COPY <span class="hljs-comment"># Copia novos arquivos e diret&#xF3;rios e os adicionam ao filesystem do container;</span>
ENTRYPOINT <span class="hljs-comment"># Permite voc&#xEA; configurar um container para rodar um execut&#xE1;vel, e quando esse execut&#xE1;vel for finalizado, o container tamb&#xE9;m ser&#xE1;;</span>
ARG <span class="hljs-comment"># Permite voc&#xEA; configurar argumentos a serem passados para constru&#xE7;&#xE3;o da imagem.</span>
CMD <span class="hljs-comment"># Executa um comando, diferente do RUN que executa o comando no momento em que est&#xE1; &quot;buildando&quot; a imagem, o CMD executa no in&#xED;cio da execu&#xE7;&#xE3;o do container;</span>
LABEL <span class="hljs-comment"># Adiciona metadados a imagem como vers&#xE3;o, descri&#xE7;&#xE3;o e fabricante;</span>
<span class="hljs-keyword">ENV</span> <span class="hljs-comment"># Informa vari&#xE1;veis de ambiente ao container;</span>
<span class="hljs-keyword">MAINTAINER</span> <span class="hljs-comment"># Autor da imagem; </span>
RUN <span class="hljs-comment"># Executa qualquer comando em uma nova camada no topo da imagem e &quot;commita&quot; as altera&#xE7;&#xF5;es. Essas altera&#xE7;&#xF5;es voc&#xEA; poder&#xE1; utilizar nas pr&#xF3;ximas instru&#xE7;&#xF5;es de seu Dockerfile;</span>
<span class="hljs-keyword">USER</span> <span class="hljs-comment"># Determina qual o usu&#xE1;rio ser&#xE1; utilizado na imagem. Por default &#xE9; o root;</span>
VOLUME <span class="hljs-comment"># Permite a cria&#xE7;&#xE3;o de um ponto de montagem no container;</span>
WORKDIR <span class="hljs-comment"># Respons&#xE1;vel por mudar do diret&#xF3;rio / (raiz) para o especificado nele;</span>
<span class="hljs-keyword">EXPOSE</span> <span class="hljs-comment"># Informa qual porta o container estar&#xE1; ouvindo;</span>
</code></pre>
<p>Quando estamos trabalhando com o ENTRYPOINT e o CMD dentro do mesmo dockerfile, o CMD somente aceita par&#xE2;metros do ENTRYPOINT.</p>
<h2 id="docker-compose">Docker-compose</h2>
<p>O <a href="https://docs.docker.com/compose/" target="_blank">Compose</a> &#xE9; uma ferramenta para escrever, em um &#xFA;nico arquivo, o provisionamento de toda a stack de sua aplica&#xE7;&#xE3;o. Ex: no docker-compose definimos quais os servi&#xE7;os a serem criados e as caracter&#xED;sticas de cada service.</p>
<p>O arquivo compose utiliza a linguagem <a href="https://en.wikipedia.org/wiki/YAML" target="_blank">YAML</a> para a configura&#xE7;&#xE3;o dos services de sua aplica&#xE7;&#xE3;o. Assim, com apenas um &#xFA;nico comando, podemos criar e inicilizar todos os containers de nossa pilha de aplica&#xE7;&#xF5;es.</p>
<h2 id="instala&#xE7;&#xE3;o">Instala&#xE7;&#xE3;o</h2>
<p>Para instalar o docker-compose, siga os passos abaixo:</p>
<pre><code class="lang-bash">sudo curl -L <span class="hljs-string">&quot;https://github.com/docker/compose/releases/download/1.29.2/docker-compose-<span class="hljs-variable">$(uname -s)</span>-<span class="hljs-variable">$(uname -m)</span>&quot;</span> -o /usr/<span class="hljs-built_in">local</span>/bin/docker-compose
sudo chmod +x /usr/<span class="hljs-built_in">local</span>/bin/docker-compose
sudo ln <span class="hljs-_">-s</span> /usr/<span class="hljs-built_in">local</span>/bin/docker-compose /usr/bin/docker-compose

<span class="hljs-comment">## testing</span>
docker-compose --version
</code></pre>
<pre><code class="lang-yml"><span class="hljs-attr">version:</span> <span class="hljs-string">&quot;3.9&quot;</span>  <span class="hljs-comment"># optional since v1.27.0</span>
<span class="hljs-attr">services:</span>
<span class="hljs-attr">  web:</span>
<span class="hljs-attr">    build:</span> .
<span class="hljs-attr">    ports:</span>
<span class="hljs-bullet">      -</span> <span class="hljs-string">&quot;5000:5000&quot;</span>
<span class="hljs-attr">    volumes:</span>
<span class="hljs-bullet">      -</span> .:/code
<span class="hljs-attr">      - logvolume01:</span>/var/log
<span class="hljs-attr">    links:</span>
<span class="hljs-bullet">      -</span> redis

<span class="hljs-attr">  redis:</span>
<span class="hljs-attr">    image:</span> redis

<span class="hljs-attr">volumes:</span>
<span class="hljs-attr">  logvolume01:</span> {}
</code></pre>

                                
                                </section>
                            
    </div>
    <div class="search-results">
        <div class="has-results">
            
            <h1 class="search-results-title"><span class='search-results-count'></span> results matching "<span class='search-query'></span>"</h1>
            <ul class="search-results-list"></ul>
            
        </div>
        <div class="no-results">
            
            <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
            
        </div>
    </div>
</div>

                        </div>
                    </div>
                
            </div>

            
                
                <a href="Ansible.html" class="navigation navigation-prev " aria-label="Previous page: Ansible">
                    <i class="fa fa-angle-left"></i>
                </a>
                
                
                <a href="GitBook.html" class="navigation navigation-next " aria-label="Next page: GitBook">
                    <i class="fa fa-angle-right"></i>
                </a>
                
            
        
    </div>

    <script>
        var gitbook = gitbook || [];
        gitbook.push(function() {
            gitbook.page.hasChanged({"page":{"title":"Docker","level":"1.4","depth":1,"next":{"title":"GitBook","level":"1.5","depth":1,"path":"GitBook.md","ref":"GitBook.md","articles":[]},"previous":{"title":"Ansible","level":"1.3","depth":1,"path":"Ansible.md","ref":"Ansible.md","articles":[]},"dir":"ltr"},"config":{"gitbook":"*","theme":"default","variables":{},"plugins":[],"pluginsConfig":{"highlight":{},"search":{},"lunr":{"maxIndexSize":1000000,"ignoreSpecialCharacters":false},"sharing":{"facebook":true,"twitter":true,"google":false,"weibo":false,"instapaper":false,"vk":false,"all":["facebook","google","twitter","weibo","instapaper"]},"fontsettings":{"theme":"white","family":"sans","size":2},"theme-default":{"styles":{"website":"styles/website.css","pdf":"styles/pdf.css","epub":"styles/epub.css","mobi":"styles/mobi.css","ebook":"styles/ebook.css","print":"styles/print.css"},"showLevel":false}},"structure":{"langs":"LANGS.md","readme":"README.md","glossary":"GLOSSARY.md","summary":"SUMMARY.md"},"pdf":{"pageNumbers":true,"fontSize":12,"fontFamily":"Arial","paperSize":"a4","chapterMark":"pagebreak","pageBreaksBefore":"/","margin":{"right":62,"left":62,"top":56,"bottom":56}},"styles":{"website":"styles/website.css","pdf":"styles/pdf.css","epub":"styles/epub.css","mobi":"styles/mobi.css","ebook":"styles/ebook.css","print":"styles/print.css"}},"file":{"path":"Docker.md","mtime":"2021-10-03T19:43:29.207Z","type":"markdown"},"gitbook":{"version":"3.2.3","time":"2021-10-04T12:07:47.563Z"},"basePath":".","book":{"language":""}});
        });
    </script>
</div>

        
    <script src="gitbook/gitbook.js"></script>
    <script src="gitbook/theme.js"></script>
    
        
        <script src="gitbook/gitbook-plugin-search/search-engine.js"></script>
        
    
        
        <script src="gitbook/gitbook-plugin-search/search.js"></script>
        
    
        
        <script src="gitbook/gitbook-plugin-lunr/lunr.min.js"></script>
        
    
        
        <script src="gitbook/gitbook-plugin-lunr/search-lunr.js"></script>
        
    
        
        <script src="gitbook/gitbook-plugin-sharing/buttons.js"></script>
        
    
        
        <script src="gitbook/gitbook-plugin-fontsettings/fontsettings.js"></script>
        
    

    </body>
</html>

